﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.CustomMarshalers;

namespace ComplusInstaller
{
    [ComImport, TypeLibType((short)0x1040), Guid("6EB22871-8A19-11D0-81B6-00A0C9231C29")]
    public interface ICatalogObject
    {
        [DispId(1)]
        object this[string bstrPropName] { [return: MarshalAs(UnmanagedType.Struct)] [DispId(1)] get; [param: In, MarshalAs(UnmanagedType.Struct)] [DispId(1)] set; }
        [DispId(2)]
        object Key { [return: MarshalAs(UnmanagedType.Struct)] [DispId(2)] get; }
        [DispId(3)]
        object Name { [return: MarshalAs(UnmanagedType.Struct)] [DispId(3)] get; }
        [DispId(4)]
        bool IsPropertyReadOnly([In, MarshalAs(UnmanagedType.BStr)] string bstrPropName);
        [DispId(5)]
        bool Valid { [DispId(5)] get; }
        [DispId(6)]
        bool IsPropertyWriteOnly([In, MarshalAs(UnmanagedType.BStr)] string bstrPropName);
    }

    public enum COMAdminApplicationInstallOptions
    {
        COMAdminInstallNoUsers,
        COMAdminInstallUsers,
        COMAdminInstallForceOverwriteOfFiles
    }

    public enum COMAdminActivationOptions
    {
        COMAdminActivationInproc,
        COMAdminActivationLocal
    }

    public enum COMAdminInUse
    {
        COMAdminNotInUse,
        COMAdminInUseByCatalog,
        COMAdminInUseByRegistryUnknown,
        COMAdminInUseByRegistryProxyStub,
        COMAdminInUseByRegistryTypeLib,
        COMAdminInUseByRegistryClsid
    }

    [ComVisible(true), Guid("496B0ABF-CDEE-11d3-88E8-00902754C43A")]
    public interface IEnumerator
    {
        bool MoveNext();
        object Current { get; }
        void Reset();
    }

    [ComVisible(true), Guid("496B0ABE-CDEE-11d3-88E8-00902754C43A")]
    public interface IEnumerable
    {
        [DispId(-4)]
        IEnumerator GetEnumerator();
    }

    [ComImport, TypeLibType((short)0x1040), Guid("6EB22872-8A19-11D0-81B6-00A0C9231C29")]
    public interface ICatalogCollection : IEnumerable
    {
        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalType = "", MarshalTypeRef = typeof(EnumeratorToEnumVariantMarshaler), MarshalCookie = "")]
        [TypeLibFunc((short)1), DispId(-4)]
        IEnumerator GetEnumerator();
        [DispId(1)]
        object this[int lIndex] { [return: MarshalAs(UnmanagedType.IDispatch)] [DispId(1)] get; }
        [DispId(0x60020002)]
        int Count { [DispId(0x60020002)] get; }
        [DispId(0x60020003)]
        void Remove([In] int lIndex);
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(0x60020004)]
        object Add();
        [DispId(2)]
        void Populate();
        [DispId(3)]
        int SaveChanges();
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(4)]
        object GetCollection([In, MarshalAs(UnmanagedType.BStr)] string bstrCollName, [In, MarshalAs(UnmanagedType.Struct)] object varObjectKey);
        [DispId(6)]
        object Name { [return: MarshalAs(UnmanagedType.Struct)] [DispId(6)] get; }
        [DispId(7)]
        bool AddEnabled { [DispId(7)] get; }
        [DispId(8)]
        bool RemoveEnabled { [DispId(8)] get; }
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(9)]
        object GetUtilInterface();
        [DispId(10)]
        int DataStoreMajorVersion { [DispId(10)] get; }
        [DispId(11)]
        int DataStoreMinorVersion { [DispId(11)] get; }
        [DispId(12)]
        void PopulateByKey([In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] Array psaKeys);
        [DispId(13)]
        void PopulateByQuery([In, MarshalAs(UnmanagedType.BStr)] string bstrQueryString, [In] int lQueryType);
    }

 
    
    [ComImport, Guid("DD662187-DFC2-11D1-A2CF-00805FC79235"), TypeLibType((short)0x1040)]
    public interface ICOMAdminCatalog
    {
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(1)]
        object GetCollection([In, MarshalAs(UnmanagedType.BStr)] string bstrCollName);
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(2)]
        object Connect([In, MarshalAs(UnmanagedType.BStr)] string bstrCatalogServerName);
        [DispId(3)]
        int MajorVersion { [DispId(3)] get; }
        [DispId(4)]
        int MinorVersion { [DispId(4)] get; }
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(5)]
        object GetCollectionByQuery([In, MarshalAs(UnmanagedType.BStr)] string bstrCollName, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarQuery);
        [DispId(6)]
        void ImportComponent([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrCLSIDOrProgID);
        [DispId(7)]
        void InstallComponent([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrDLL, [In, MarshalAs(UnmanagedType.BStr)] string bstrTLB, [In, MarshalAs(UnmanagedType.BStr)] string bstrPSDLL);
        [DispId(8)]
        void ShutdownApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName);
        [DispId(9)]
        void ExportApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationFile, [In] int lOptions);
        [DispId(10)]
        void InstallApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationFile, [In, Optional, MarshalAs(UnmanagedType.BStr)] string bstrDestinationDirectory, [In, Optional] int lOptions, [In, Optional, MarshalAs(UnmanagedType.BStr)] string bstrUserId, [In, Optional, MarshalAs(UnmanagedType.BStr)] string bstrPassword, [In, Optional, MarshalAs(UnmanagedType.BStr)] string bstrRSN);
        [DispId(11)]
        void StopRouter();
        [DispId(12)]
        void RefreshRouter();
        [DispId(13)]
        void StartRouter();
        [DispId(14)]
        void Reserved1();
        [DispId(15)]
        void Reserved2();
        [DispId(0x10)]
        void InstallMultipleComponents([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarFileNames, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarCLSIDs);
        [DispId(0x11)]
        void GetMultipleComponentsInfo([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarFileNames, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarCLSIDs, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarClassNames, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarFileFlags, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarComponentFlags);
        [DispId(0x12)]
        void RefreshComponents();
        [DispId(0x13)]
        void BackupREGDB([In, MarshalAs(UnmanagedType.BStr)] string bstrBackupFilePath);
        [DispId(20)]
        void RestoreREGDB([In, MarshalAs(UnmanagedType.BStr)] string bstrBackupFilePath);
        [DispId(0x15)]
        void QueryApplicationFile([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationFile, [MarshalAs(UnmanagedType.BStr)] out string pbstrApplicationName, [MarshalAs(UnmanagedType.BStr)] out string pbstrApplicationDescription, out bool pbHasUsers, out bool pbIsProxy, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarFileNames);
        [DispId(0x16)]
        void StartApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName);
        [DispId(0x17)]
        int ServiceCheck([In] int lService);
        [DispId(0x18)]
        void InstallMultipleEventClasses([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarFileNames, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarCLSIDs);
        [DispId(0x19)]
        void InstallEventClass([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrDLL, [In, MarshalAs(UnmanagedType.BStr)] string bstrTLB, [In, MarshalAs(UnmanagedType.BStr)] string bstrPSDLL);
        [DispId(0x1a)]
        void GetEventClassesForIID([In, MarshalAs(UnmanagedType.BStr)] string bstrIID, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarCLSIDs, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarProgIDs, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarDescriptions);
    }

    [ComImport, Guid("790C6E0B-9194-4CC9-9426-A48A63185696"), TypeLibType((short)0x1040)]
    public interface ICOMAdminCatalog2 : ICOMAdminCatalog
    {
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(1)]
        object GetCollection([In, MarshalAs(UnmanagedType.BStr)] string bstrCollName);
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(2)]
        object Connect([In, MarshalAs(UnmanagedType.BStr)] string bstrCatalogServerName);
        [DispId(3)]
        int MajorVersion { [DispId(3)] get; }
        [DispId(4)]
        int MinorVersion { [DispId(4)] get; }
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(5)]
        object GetCollectionByQuery([In, MarshalAs(UnmanagedType.BStr)] string bstrCollName, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarQuery);
        [DispId(6)]
        void ImportComponent([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrCLSIDOrProgID);
        [DispId(7)]
        void InstallComponent([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrDLL, [In, MarshalAs(UnmanagedType.BStr)] string bstrTLB, [In, MarshalAs(UnmanagedType.BStr)] string bstrPSDLL);
        [DispId(8)]
        void ShutdownApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName);
        [DispId(9)]
        void ExportApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationFile, [In] int lOptions);
        [DispId(10)]
        void InstallApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationFile, [In, Optional, MarshalAs(UnmanagedType.BStr)] string bstrDestinationDirectory, [In, Optional] int lOptions, [In, Optional, MarshalAs(UnmanagedType.BStr)] string bstrUserId, [In, Optional, MarshalAs(UnmanagedType.BStr)] string bstrPassword, [In, Optional, MarshalAs(UnmanagedType.BStr)] string bstrRSN);
        [DispId(11)]
        void StopRouter();
        [DispId(12)]
        void RefreshRouter();
        [DispId(13)]
        void StartRouter();
        [DispId(14)]
        void Reserved1();
        [DispId(15)]
        void Reserved2();
        [DispId(0x10)]
        void InstallMultipleComponents([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarFileNames, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarCLSIDs);
        [DispId(0x11)]
        void GetMultipleComponentsInfo([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarFileNames, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarCLSIDs, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarClassNames, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarFileFlags, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarComponentFlags);
        [DispId(0x12)]
        void RefreshComponents();
        [DispId(0x13)]
        void BackupREGDB([In, MarshalAs(UnmanagedType.BStr)] string bstrBackupFilePath);
        [DispId(20)]
        void RestoreREGDB([In, MarshalAs(UnmanagedType.BStr)] string bstrBackupFilePath);
        [DispId(0x15)]
        void QueryApplicationFile([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationFile, [MarshalAs(UnmanagedType.BStr)] out string pbstrApplicationName, [MarshalAs(UnmanagedType.BStr)] out string pbstrApplicationDescription, out bool pbHasUsers, out bool pbIsProxy, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarFileNames);
        [DispId(0x16)]
        void StartApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName);
        [DispId(0x17)]
        int ServiceCheck([In] int lService);
        [DispId(0x18)]
        void InstallMultipleEventClasses([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarFileNames, [In, MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] ref Array ppsaVarCLSIDs);
        [DispId(0x19)]
        void InstallEventClass([In, MarshalAs(UnmanagedType.BStr)] string bstrApplIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrDLL, [In, MarshalAs(UnmanagedType.BStr)] string bstrTLB, [In, MarshalAs(UnmanagedType.BStr)] string bstrPSDLL);
        [DispId(0x1a)]
        void GetEventClassesForIID([In, MarshalAs(UnmanagedType.BStr)] string bstrIID, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarCLSIDs, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarProgIDs, [MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] out Array ppsaVarDescriptions);
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(0x1b)]
        object GetCollectionByQuery2([In, MarshalAs(UnmanagedType.BStr)] string bstrCollectionName, [In, MarshalAs(UnmanagedType.Struct)] ref object pVarQueryStrings);
        [return: MarshalAs(UnmanagedType.BStr)]
        [DispId(0x1c)]
        string GetApplicationInstanceIDFromProcessID([In] int lProcessID);
        [DispId(0x1d)]
        void ShutdownApplicationInstances([In, MarshalAs(UnmanagedType.Struct)] ref object pVarApplicationInstanceID);
        [DispId(30)]
        void PauseApplicationInstances([In, MarshalAs(UnmanagedType.Struct)] ref object pVarApplicationInstanceID);
        [DispId(0x1f)]
        void ResumeApplicationInstances([In, MarshalAs(UnmanagedType.Struct)] ref object pVarApplicationInstanceID);
        [DispId(0x20)]
        void RecycleApplicationInstances([In, MarshalAs(UnmanagedType.Struct)] ref object pVarApplicationInstanceID, [In] int lReasonCode);
        [DispId(0x21)]
        bool AreApplicationInstancesPaused([In, MarshalAs(UnmanagedType.Struct)] ref object pVarApplicationInstanceID);
        [return: MarshalAs(UnmanagedType.BStr)]
        [DispId(0x22)]
        string DumpApplicationInstance([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationInstanceID, [In, MarshalAs(UnmanagedType.BStr)] string bstrDirectory, [In] int lMaxImages);
        [DispId(0x23)]
        bool IsApplicationInstanceDumpSupported { [DispId(0x23)] get; }
        [DispId(0x24)]
        void CreateServiceForApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrServiceName, [In, MarshalAs(UnmanagedType.BStr)] string bstrStartType, [In, MarshalAs(UnmanagedType.BStr)] string bstrErrorControl, [In, MarshalAs(UnmanagedType.BStr)] string bstrDependencies, [In, MarshalAs(UnmanagedType.BStr)] string bstrRunAs, [In, MarshalAs(UnmanagedType.BStr)] string bstrPassword, [In] bool bDesktopOk);
        [DispId(0x25)]
        void DeleteServiceForApplication([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationIDOrName);
        [return: MarshalAs(UnmanagedType.BStr)]
        [DispId(0x26)]
        string GetPartitionID([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationIDOrName);
        [return: MarshalAs(UnmanagedType.BStr)]
        [DispId(0x27)]
        string GetPartitionName([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationIDOrName);
        [DispId(40)]
        string CurrentPartition { [param: In, MarshalAs(UnmanagedType.BStr)] [DispId(40)] set; }
        [DispId(0x29)]
        string CurrentPartitionID { [return: MarshalAs(UnmanagedType.BStr)] [DispId(0x29)] get; }
        [DispId(0x2a)]
        string CurrentPartitionName { [return: MarshalAs(UnmanagedType.BStr)] [DispId(0x2a)] get; }
        [DispId(0x2b)]
        string GlobalPartitionID { [return: MarshalAs(UnmanagedType.BStr)] [DispId(0x2b)] get; }
        [DispId(0x2c)]
        void FlushPartitionCache();
        [DispId(0x2d)]
        void CopyApplications([In, MarshalAs(UnmanagedType.BStr)] string bstrSourcePartitionIDOrName, [In, MarshalAs(UnmanagedType.Struct)] ref object pVarApplicationID, [In, MarshalAs(UnmanagedType.BStr)] string bstrDestinationPartitionIDOrName);
        [DispId(0x2e)]
        void CopyComponents([In, MarshalAs(UnmanagedType.BStr)] string bstrSourceApplicationIDOrName, [In, MarshalAs(UnmanagedType.Struct)] ref object pVarCLSIDOrProgID, [In, MarshalAs(UnmanagedType.BStr)] string bstrDestinationApplicationIDOrName);
        [DispId(0x2f)]
        void MoveComponents([In, MarshalAs(UnmanagedType.BStr)] string bstrSourceApplicationIDOrName, [In, MarshalAs(UnmanagedType.Struct)] ref object pVarCLSIDOrProgID, [In, MarshalAs(UnmanagedType.BStr)] string bstrDestinationApplicationIDOrName);
        [DispId(0x30)]
        void AliasComponent([In, MarshalAs(UnmanagedType.BStr)] string bstrSrcApplicationIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrCLSIDOrProgID, [In, MarshalAs(UnmanagedType.BStr)] string bstrDestApplicationIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrNewProgId, [In, MarshalAs(UnmanagedType.BStr)] string bstrNewClsid);
        [DispId(0x31)]
        COMAdminInUse IsSafeToDelete([In, MarshalAs(UnmanagedType.BStr)] string bstrDllName);
        [DispId(50)]
        void ImportUnconfiguredComponents([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationIDOrName, [In, MarshalAs(UnmanagedType.Struct)] ref object pVarCLSIDOrProgID, [In, Optional, MarshalAs(UnmanagedType.Struct)] ref object pVarComponentType);
        [DispId(0x33)]
        void PromoteUnconfiguredComponents([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationIDOrName, [In, MarshalAs(UnmanagedType.Struct)] ref object pVarCLSIDOrProgID, [In, Optional, MarshalAs(UnmanagedType.Struct)] ref object pVarComponentType);
        [DispId(0x34)]
        void ImportComponents([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationIDOrName, [In, MarshalAs(UnmanagedType.Struct)] ref object pVarCLSIDOrProgID, [In, Optional, MarshalAs(UnmanagedType.Struct)] ref object pVarComponentType);
        [DispId(0x35)]
        bool Is64BitCatalogServer { [DispId(0x35)] get; }
        [DispId(0x36)]
        void ExportPartition([In, MarshalAs(UnmanagedType.BStr)] string bstrPartitionIDOrName, [In, MarshalAs(UnmanagedType.BStr)] string bstrPartitionFileName, [In] int lOptions);
        [DispId(0x37)]
        void InstallPartition([In, MarshalAs(UnmanagedType.BStr)] string bstrFileName, [In, MarshalAs(UnmanagedType.BStr)] string bstrDestDirectory, [In] int lOptions, [In, MarshalAs(UnmanagedType.BStr)] string bstrUserId, [In, MarshalAs(UnmanagedType.BStr)] string bstrPassword, [In, MarshalAs(UnmanagedType.BStr)] string bstrRSN);
        [return: MarshalAs(UnmanagedType.IDispatch)]
        [DispId(0x38)]
        object QueryApplicationFile2([In, MarshalAs(UnmanagedType.BStr)] string bstrApplicationFile);
        [DispId(0x39)]
        int GetComponentVersionCount([In, MarshalAs(UnmanagedType.BStr)] string bstrCLSIDOrProgID);
    }







}
